import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;

public class IdeiaServer 
{
	public Vector clientVector;         // vector of currently connected clients
	private int id_telepointer = 1;
	private Vector telepointers = new Vector();
	private ArrayList userList = new ArrayList(); // Lista contendo os usurios e senhas
	
	public FileWriter LogChat;
	public FileWriter LogLock;
	public FileWriter LogJanelaLock;
	
	public void IdeiaServer(){
		
	}
	
	public void IniciaServico(int port) throws IOException {
		// Abre o servidor na porta 123
        ServerSocket ss = new  ServerSocket(port);
		System.out.println("Server listening on port " + port +".CTRL+C to finish.") ;

		// Iniciando a lista de usuarios e senhas

    	String []x = {"mauro" ,"123"};

    	userList.add (x);
    	String []y = {"hirata" ,"123"};
		userList.add (y);

		// Configurando os arquivos de logs
		try
		{ 
			LogChat = new FileWriter("c:\\LogChat.txt",true);
			LogLock = new FileWriter("c:\\LogLock.txt",true);
			LogJanelaLock = new FileWriter("c:\\LogJanelaLock.txt",true);

			LogaMsg("Chat Log Started",0);
			LogaMsg("Lock Log Started",1);
			LogaMsg("JanelaLock Log Started",2);
			
			clientVector = new Vector(); 
			IdeiaServerT c;
			// A cada nova requiso uma nova Thread  criada
			while (true)
			{
				c = new IdeiaServerT (ss.accept(),this);
				c.start();
				
				// clientVector.addElement(c);
			}
			
		}
		catch (Exception ex)
		{
        		ex.printStackTrace();
		}
		
	}

	
	public static void main (String args[] ) 
	{

		// Checagens dos parmetros
		if(args.length!=1)
			System.out.println("Uso: IdeiaServer port");
		
		int port = 0;

		try
		{ 
			port =	Integer.valueOf(args[0]).intValue();


		}
		catch (NumberFormatException ex)
		{
		   System.out.println("Invalid port number");  
		}

	
		try
		{ 
			IdeiaServer s = new IdeiaServer();
			s.IniciaServico(port);
		}
		catch (IOException ex)
		{
			   System.out.println("Servidor finalizado!" );
		}
		
	}
	
	public void RemoveClient (IdeiaServerT singleThread) {
        	clientVector.removeElement(singleThread);
    }
	
	
    public void BroadCastToAll (Object objrecebido, IdeiaServerT tEnviada, boolean skipItself) 	
    {
    	this.BroadCastToAll(objrecebido,tEnviada,skipItself,tEnviada.tipocon);
    }
    	
    public void BroadCastToAll (Object objrecebido, IdeiaServerT tEnviada, boolean skipItself,String tipocon) 	{
        ArrayList list = (ArrayList) objrecebido;

        Object eventoMouse = list.get(0);
        String nomeEvento = (String)list.get(1);
        
        IdeiaServerT aSingleThread = null;
        
        for (int i = 0; i < clientVector.size(); i++) {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            if(skipItself)
            {
            	if( (!aSingleThread.equals(tEnviada)) && 
                	(aSingleThread.tipocon.equals(tipocon)) && 
                	(aSingleThread.nome_sessao.equals(tEnviada.nome_sessao))  )
                	
                	aSingleThread.BroadCastToClient(list);
            }
            else
            {
                if( 	(aSingleThread.tipocon.equals(tipocon)) && 
	                	(aSingleThread.nome_sessao.equals(tEnviada.nome_sessao))  )
            	
                		aSingleThread.BroadCastToClient(list);
            	
            }
                
        }
	}

    
    
    
    public boolean ExisteSessao (String nomesessao) {
        IdeiaServerT aSingleThread = null;
        
        for (int i = 0; i < clientVector.size(); i++) {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            if( aSingleThread.nome_sessao.equals(nomesessao))
            	return true;
        }
        return false;
    }
    
    
    // Obtem o modelo atual da sesso de algum dos participantes
    public Object ModeloSessao (String nomesessao) {
        IdeiaServerT aSingleThread = null;
        
        for (int i = 0; i < clientVector.size(); i++) {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            if( aSingleThread.nome_sessao.equals(nomesessao))
            	return  aSingleThread.modelo_atual;
        }
        return null;
    }

    // Obtem o modelo atual da sesso de algum dos participantes
    public ArrayList ModeloSessaoInicial (String nomesessao) {
        IdeiaServerT aSingleThread = null;
        
        for (int i = 0; i < clientVector.size(); i++) {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            if( aSingleThread.nome_sessao.equals(nomesessao))
            	return  aSingleThread.modelo_inicial;
        }
        return null;
    }
    
    // retorna todas os nomes da seses colaborativas atuais
    public Vector NomeSessoes () {
        IdeiaServerT aSingleThread = null;
        Vector ret_aux = new Vector();
        Vector retorno  = new Vector();
        String nome_sessao = "";
        String user_sessao = "";
        
        // Neste primeiro loop eu objenho todos os nomes das sessoes
        for (int i = 0; i < clientVector.size(); i++) 
        {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            if(  !ret_aux.contains(aSingleThread.nome_sessao) && !aSingleThread.nome_sessao.equals("")  )
            {
            	ret_aux.addElement(aSingleThread.nome_sessao);
            }
        }
        
        // Aqui objeto os usuarios de cada sessao
        for (int i = 0; i < ret_aux.size(); i++) 
        {
        	    nome_sessao = (String) ret_aux.get(i);
				user_sessao = "";  
				
                for (int j = 0; j < clientVector.size(); j++) 
                {
                    aSingleThread = (IdeiaServerT) clientVector.elementAt(j);
                    
                    if(aSingleThread.nome_sessao.equals(nome_sessao) && user_sessao.indexOf(aSingleThread.login) == -1 )
                    {
                    	user_sessao = user_sessao  + ";" + aSingleThread.login;     	
                    }
                }
        	    String []inserir = { nome_sessao, user_sessao.substring(1,user_sessao.length()) };
        	    
        	    retorno.add(inserir);    
        }
        
        return retorno;
    }
    
    // CheckLock verifica se existe um lock na fig e pode remover este lock
    
    public boolean CheckLock (String fig) 
    {
    	return this.CheckLock(fig,false);
    }
    
    public boolean CheckLock (String fig,boolean remove) 
    {
        IdeiaServerT aSingleThread = null;

        for (int i = 0; i < clientVector.size(); i++) {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            if( aSingleThread.resources_locked.contains(fig) )
            {
            	if(remove)
            		aSingleThread.resources_locked.remove(fig);	

            	return true;
            }
        }
        return false;
    }
    
    public ArrayList getLockStatus () {
        
    	ArrayList ret = new ArrayList();
    	IdeiaServerT aSingleThread = null;
        Vector r;
        
        String logaJanela = "";

        for (int i = 0; i < clientVector.size(); i++) 
        {
            aSingleThread = (IdeiaServerT) clientVector.elementAt(i);

            r = aSingleThread.resources_locked;
            
            for (int j = 0; j < r.size(); j++) 
            {
            	// ret.add((String)  r.elementAt(j) );
            	
            	logaJanela = logaJanela + " usuario:" + aSingleThread.login + " - objeto: "  + (String)  r.elementAt(j) + ","; 
            	
            	String []x = {aSingleThread.login ,(String)  r.elementAt(j)};
            	
            	ret.add(x);
            	
            }
        }
        
        // Toda a vez que solicitarem o status global dos locks vou 
        // logar em um arquivo separado
        
        this.LogaMsg(logaJanela,2);
        
        return ret; 
    }

    public String getPointerID()
    {

    	String x = "1";
    	
    	for (int i = 0; i < 4; i++) 
    	{
    		id_telepointer = i+1;
    		if(!telepointers.contains(String.valueOf(id_telepointer)) )
    		{
    			x = String.valueOf(id_telepointer);
    			
    			telepointers.addElement(x); 
    			
    			return x;
    		}
    	}
    	
    	return x;
    }

    
    public Color getColor(String id)
    {
    	
    	// Aqui vou especificar as colores e os ID's dos telepointers
    	Color fColor = Color.black;
		if (id=="1") fColor = Color.black; 
		if (id=="2") fColor = Color.blue;
		if (id=="3") fColor = Color.yellow;
		if (id=="4") fColor = Color.orange;
		
		return fColor;
    }
    
    public void RemovePointer(String id)
    {
    		if(telepointers.contains(id) )
    			telepointers.removeElement(id);
    		
    		return;
    }

    public boolean checkUser(String l,String s)
    {
        for (int i = 0; i < userList.size(); i++) 
        {
            String user[] = (String []) userList.get(i);
            
            if(user[0].equals(l) && user[1].equals(s))
            	return true;
        }
        
        return false;
    }

    public void LogaMsg(String msg,int tipo) // 0 -> Chat, 1->Lock, 2->Janela de lock
    {
		// Logando o que foi falado no Chat...
		try
		{ 
			java.util.Date now = new java.util.Date();  

			String myString = java.text.DateFormat.getDateInstance().format(now); 
			String myString1 = java.text.DateFormat.getTimeInstance().format(now); 

			if(tipo==0)
			{
				// Logando a mensagem de chat
				this.LogChat.write(myString + "-" + myString1+ " " +msg+"\n\n");
				this.LogChat.flush();
			}
			
			
			if(tipo==1)
			{
//				 Logando a mensagem de lock
				this.LogLock.write(myString + "-" + myString1+ " " +msg+"\n\n");
				this.LogLock.flush();
			}
			if(tipo==2)
			{
//				 Logando a mensagem da janela de lock
				this.LogJanelaLock.write(myString + "-" + myString1+ " " +msg+"\n\n");
				this.LogJanelaLock.flush();
			}
		}
		catch (Exception ee) 
		{
			ee.printStackTrace();
		} 
    }
    
    
}

class IdeiaServerT extends Thread 
{
	Socket client;
    private ObjectInputStream is;
    private ObjectOutputStream os;
    private IdeiaServer servidor;
    private String id_pointer;
    public String tipocon; 
    public String login;
    public String senha;
    public String nome_sessao = "";
    public Object modelo_atual;
    public ArrayList modelo_inicial = new ArrayList();
    
    public Vector resources_locked = new Vector();
	
	// Construtor da classe
	IdeiaServerT (Socket client,IdeiaServer s) throws SocketException 
	{

		// Preenche os campos e seta a priopridade desta Thread
		this.client = client;
		this.servidor = s;
		setPriority( NORM_PRIORITY - 1);
		this.tipocon = "";


	}

	public void run() 
	{
        try {
            this.connect();
            boolean clientTalking = true;
            
            //a loop that reads from and writes to the socket
            while (clientTalking) {
                // get what client wants to say...
                Object clientObject = is.readObject();
                // System.out.println("Servidor recebeu algum objeto!");

                
                if(!this.trataProtocolo(clientObject))
                {
	                // if client dissappeared.. 
	                if (clientObject == null) 
	                    clientTalking = false;
	                 else 
	                 	// Preciso mandar o objeto somente para os clientes
	                 	// que participarem da mesma sesso
	                 	this.servidor.BroadCastToAll(clientObject, this, true);
               	}
                
            }
            
        } catch (Exception e) {
        	// System.out.println("Conexo fechada pelo cliente.");
        	// e.printStackTrace();
        }
        this.disconnect();
	}
	

	// Trata as mensagens do protocolo
	private boolean trataProtocolo (Object clientObject) 
	{

        ArrayList list = (ArrayList) clientObject;

        Object objDados = list.get(0);
        String nomeEvento = (String)list.get(1);
        
        
        // Aqui so verificadas as mensagens iniciais, para identificar qual  a conexo
        if (  (nomeEvento.equals("GEF")) || (nomeEvento.equals("ARGO")) )
        {
        	ArrayList l = (ArrayList) objDados;
        	
        	// Aqui ser verificado o login e a senha.
        	
        	if ( this.servidor.checkUser(l.get(0).toString(),l.get(1).toString())  )
        	{
        		this.tipocon = nomeEvento;
        		this.login = l.get(0).toString();
        		this.senha = l.get(1).toString();
        		 // System.out.println("Conexo autorizada!");
        		
        		// Adicionando ao array de clientes
        		this.servidor.clientVector.addElement(this);
        		
        		// Enviar para o cliente o nome das sesses!
        		l = new ArrayList();
	        	l.add(this.servidor.NomeSessoes()); 
	        	l.add("PROT_lista_sessoes");

	        	if(nomeEvento.equals("ARGO"))
	        	{
		        	// Aqui vou colocar uma cor para o telepointer do cliente
	        		id_pointer = this.servidor.getPointerID(); 
		        	l.add(id_pointer);
		        	l.add(this.servidor.getColor(id_pointer));
		        	
	        	}
	        	
				this.BroadCastToClient(l);
        	}
        	else
        	{
        		l = new ArrayList();
        		l.add("ERRO");
	        	l.add("ERRO");
	        	this.BroadCastToClient(l);
	        	
	        	// servidor.RemovePointer(id_pointer);
	            // servidor.RemoveClient(this);
        		
        		// this.disconnect();
        	}
        	return true;
        }

        
        
        
		// Aqui so verificadas as mensagens de 'protocolo'
    	if (  nomeEvento.startsWith("PROT") )
    	{
    		// O cliente quer abrir uma noca sesso
    		if (nomeEvento.equals("PROT_nova_sessao"))
    		{
    			ArrayList li = (ArrayList) objDados;
				
    			
    			// A verificao da possvel criao de uma sesso que
    			// j exista deve ser feita no ArgoUML e no no servidor!
    			
				this.nome_sessao = ((String) li.get(0));
				
				// Colocando o modelo do diagrama atual no servidor
				// this.modelo_atual = ((String) li.get(1));

				// System.out.println("Sessao " +this.nome_sessao+ " criada!");
				
				this.modelo_inicial = ((ArrayList) li.get(1));
    				
				// Logando o horrio que o usurio entrou na sessao
				this.servidor.LogaMsg( login + " entrou na sessao:" + this.nome_sessao,0);
    		}
    		
		
    		// O cliente quer participar de uma sesso existente
    		if (nomeEvento.equals("PROT_sessao_existente"))
    		{
    			
    			if(this.servidor.ExisteSessao((String) objDados) )
    			{
    				// Aqui so feitas as devidas iniciaes da sesso colaborativa
    				this.nome_sessao = (String) objDados;

    				// Obtem o modelo desta sesso de algum dos participantes
    				this.modelo_inicial = this.servidor.ModeloSessaoInicial(this.nome_sessao);
    				this.modelo_atual = this.servidor.ModeloSessao(this.nome_sessao);
    				
    				
    				// Envia este modelo para o cliente, para que
    				// ele atualize o seu modelo
	    			ArrayList l = new ArrayList();
	        		l.add(this.modelo_inicial); 
	        		l.add("PROT_atualiza_modelo_cliente_inicial"); 
				
    				this.BroadCastToClient(l);
    				
//    				 Logando o horrio que o usurio entrou na sessao
    				this.servidor.LogaMsg( login + " entrou na sessao:" + this.nome_sessao,0);
    				
    			}
    		}	
        		
//    		 O cliente quer participar de uma sesso existente
    		if (nomeEvento.equals("PROT_chat_msg"))
    		{
    			// Montando o objeto que ser replicado
    			ArrayList l = new ArrayList();
	        	l.add(login + ":" + ((String) objDados)); 
	        	l.add("PROT_chat_msg");
    			
    			this.servidor.BroadCastToAll(l, this, false);
			
    			// 	Logando a conversa em um arquivo
    			this.servidor.LogaMsg( login + ":" + ((String) objDados),0 );

    		}
    		
    		if (nomeEvento.equals("PROT_fim_sessao"))
    		{
//				 Logando o horrio que o usurio entrou na sessao
				this.servidor.LogaMsg( login + " saiu na sessao:" + this.nome_sessao,0);
    		}
    		
    		
            ////////////////////////////////////LOCK////////////////////////////////////////////
    		// Aqui sera verificado se o lock solicitado pode ser liberado
    		if (nomeEvento.equals("PROT_lock_request"))
    		{
	    			ArrayList l = new ArrayList();
	    			l.add(((String) objDados));
	    		
	    			// System.out.println("Lock request on:" + ((String) objDados));
	    			this.servidor.LogaMsg( login + ":" + " Lock request on:" + ((String) objDados)  ,1 );
    			
    				if (!this.servidor.CheckLock(  ((String) objDados) ))
    				{
    					this.resources_locked.addElement( ((String) objDados) );

    					this.servidor.LogaMsg( login + ":" + " Lock granted on:" + ((String) objDados)  ,1 );
						l.add("PROT_lock_granted"); 
						// System.out.println("Lock granted on:" + ((String) objDados));
						
	    				// Manda o status para os clientes
	    				this.BroadLockStatusToAll();
    				}
    				else
    				{
    					// Aqui vou fazer uma verificao. Se for esta conexo
    					// que esta com o lock, retornar OK
    					
    					if(this.resources_locked.contains((String) objDados) )
    					{
    					
    						this.servidor.LogaMsg( login + ":" + " Lock granted on:" + ((String) objDados)  ,1 );
    						l.add("PROT_lock_granted"); 
    						// System.out.println("Lock alredy granted on:" + ((String) objDados));
    						
    	    				// Manda o status para os clientes
    	    				this.BroadLockStatusToAll();
    					}
    					else
    					{
    						this.servidor.LogaMsg( login + ":" + " Lock deny on:" + ((String) objDados)  ,1 );
    						l.add("PROT_lock_deny");
    						// System.out.println("Lock deny on:" + ((String) objDados));
    					}
    				}
    	        	
    				// Manda a resposta da requisito de lock
    				this.BroadCastToClient(l);
    				
    		}
        		
    		// Aqui sera verificado se os locks solicitados pode ser liberado
    		// Lock multiplo
    		if (nomeEvento.equals("PROT_lock_request_group"))
    		{
    				// O ArrayList abaixo vai montar a mensagem de lock_ok ou lock_deny
    				ArrayList l = new ArrayList();
    				
    				ArrayList liberados = new ArrayList();
    			
    				// Este ArrayList vai conter os objetos que querem lock 
    				ArrayList objs = (ArrayList) objDados;
    				
    				l.add(objs);
    				
    				boolean lock_ok = true;
    				
    				// Varrendo a ArrayList dos objetos que querem lock
    				for(int i = 0;i<objs.size();i++)
        			{
						if (!this.servidor.CheckLock(  (String) objs.get(i)  ))
						{
							liberados.add((String) objs.get(i));
						}
						else
						{
							//	Aqui vou fazer uma verificao. Se for esta conexo
	    					// que esta com o lock, OK, seno retorna erro! 
	    					if(!this.resources_locked.contains( (String) objs.get(i)  ))
	    						lock_ok = false;
						}
        			}
    				
    				String elementos ="";
    				
    				// Vendo se todos os locks estao ok
    				if(lock_ok)
    				{
    					// Agora vou colocar efetivamente o lock em todo mundo
    					for(int i = 0;i<liberados.size();i++)
            			{
    						this.resources_locked.addElement( (String) liberados.get(i) );
    						
    						elementos = elementos + "," + (String) liberados.get(i);
            			}
    					
    					// Mandando a mensagem
    					l.add("PROT_lock_granted");
    					
    					this.servidor.LogaMsg( login + ":" + " Lock request group granted:" + elementos,1 );
    				}
    				else
    				{
    					l.add("PROT_lock_deny");
    					this.servidor.LogaMsg( login + ":" + " Lock request group denyed:" + elementos,1 );	
    				}
    				
    				// Enviando a notificao para os outros clientes
    				this.BroadLockStatusToAll();
    				
    				// Enviado a mensagem para o cliente
    				this.BroadCastToClient(l);
    				
    		}
    		
    		// Aqui libera os locks que existem nas figuras
    		if (nomeEvento.equals("PROT_lock_release"))
    		{
				// System.out.println("Lock release on:" + ((String) objDados));
    			this.servidor.LogaMsg( login + ":" + " Lock release on:" + ((String) objDados)  ,1 );
    			this.resources_locked.remove(((String) objDados));
    			
				// Manda o status para os clientes
				this.BroadLockStatusToAll();
    			
    		}
    		if (nomeEvento.equals("PROT_lock_clear"))
    		{
    			
    			// Antes de fazer o lock clear eu preciso montar um array 
    			// contendo os id's dos elementos que perderam o lock
    			// e que podem ter um novo nome
    			ArrayList modificados = new ArrayList();
    			
    			String compara = "";

    			if(objDados != null)
    			{
	    			ArrayList nomesElementos = (ArrayList) objDados;
	    			
	    			for(int i=0;i<nomesElementos.size();i++)
	    			{
	    				String dados[] = (String []) nomesElementos.get(i);
	    				
	    				// So o nome 'antigo' for branco, pergunta pelo nome novo
	    				if(dados[1].equals(""))
	    					compara = dados[0]; 
	    				else
	    					compara = dados[1];
	    				
	    				if( resources_locked.contains(compara) )
	    				{
	    	            	String []x = {dados[0],dados[1],dados[2],dados[3],dados[4],dados[5],dados[6]};
	    	            	
	    	            	modificados.add(x);
	    				}
	    			}
    			}
    			
    			// Agora posso apagar todos os elementos
    			this.servidor.LogaMsg( login + ":" + " Lock clear",1 );
    			this.resources_locked.clear(); 
    			// System.out.println("Lock Clear" );
    			
				// Manda o status para os clientes
				this.BroadLockStatusToAll(modificados);
    			
    		}
    		if (nomeEvento.equals("PROT_lock_clear_almost"))
    		{
    		
    			ArrayList modificados = new ArrayList();
    			
    			if(list.size() > 2)
    			{
    				ArrayList nomesElementos = (ArrayList) list.get(2);
	    			
	    			for(int i=0;i<nomesElementos.size();i++)
	    			{
	    				String dados[] = (String []) nomesElementos.get(i);
	    				
	    				if( resources_locked.contains(dados[1]) )
	    				{
	    					String []x = {dados[0],dados[1],dados[2],dados[3],dados[4],dados[5],dados[6]};
	    	            	
	    	            	modificados.add(x);
	    				}
	    			}
    			}
    			
    			// Vou limpar os locks em todos, menos os que ja esto selecionados
    			this.resources_locked.clear(); 
    			
    			ArrayList selecionados = (ArrayList) objDados;
    			
    			String elementos ="";
    			
    			for(int i = 0;i<selecionados.size();i++)
    			{
    				// Preciso retirar o lock da Thread que a possui!
    				
    				this.resources_locked.addElement( selecionados.get(i) );
    				elementos = elementos + "," + selecionados.get(i);
    			}
    			
    			
    			this.servidor.LogaMsg( login + ":" + " Lock clear almost:" + elementos,1 );
    			
				// 	Manda o status para os clientes
				this.BroadLockStatusToAll(modificados);
    			
    			// System.out.println("Lock Released - liberando todos os locks menos os selecioandos" );
    		}
            ////////////////////////////////////LOCK////////////////////////////////////////////
    		
    		if (nomeEvento.equals("PROT_remove_elemento"))
    		{
    			ArrayList selecionados = (ArrayList) objDados;

    			for(int i = 0;i<selecionados.size();i++)
    			{
        			this.servidor.LogaMsg( login + ":" + " Lock release on:" + ((String) selecionados.get(i))  ,1 );
        			this.servidor.CheckLock( (String) selecionados.get(i), true);
    			}
    			
    			// Manda o status para os clientes
				this.BroadLockStatusToAll();
				
				// Vou encaminhar a mensagem PROT_remove_elemento para os demais usurios
				return false;
    		}
    		
    		
    		//  O cliente mandou um modelo para ser atualizado nos clientes
    		// Porem somente os clientes que so da mesma sesso!
    		if (nomeEvento.equals("PROT_atualiza_modelo_servidor"))
    		{
    			// Atualizando o modelo desta thread
    			this.modelo_atual = (Object) objDados;
    			
    			// System.out.println("Cliente mandou o modelo:" + this.modelo_atual);
    			
    			// Montando o objeto que ser replicado
    			ArrayList l = new ArrayList();
	        	l.add(this.modelo_atual); 
	        	l.add("PROT_atualiza_modelo_cliente");
    			
    			this.servidor.BroadCastToAll(l, this, true);
    			
        	}
    		
    		return true;
    	}

		return false;
	}

	
    private void BroadLockStatusToAll () 	{
        // ArrayLista que vai conter as notificaes dos clientes (cores)
        ArrayList avisa;
        ArrayList manda = new ArrayList();

        avisa = this.servidor.getLockStatus(); 
		
        manda.add(avisa);
        manda.add("PROT_notify_lock");

		this.servidor.BroadCastToAll(manda, this, true,"GEF");
    
    }   
	
    private void BroadLockStatusToAll (ArrayList nomes) 	
    {
        // ArrayLista que vai conter as notificaes dos clientes (cores)
        ArrayList avisa;
        ArrayList manda = new ArrayList();

        avisa = this.servidor.getLockStatus(); 
		
        manda.add(avisa);
        manda.add("PROT_notify_lock");
        manda.add(nomes);

		this.servidor.BroadCastToAll(manda, this, true,"GEF");
    
    }
    
	// when connection starts - opens streams and calls server to notify
    // all other currently connected clients about the joining of this user.
    private void connect () throws java.io.IOException	{

    	is = new ObjectInputStream(client.getInputStream());
        os = new ObjectOutputStream(client.getOutputStream());

        os.flush();
    }   
    
    //  when connection ends - closes streams, stops this thread and notifies
    // server about the disconnection of this client.
    private void disconnect () {
        try {
            is.close();
            os.close();
            
            client.close();
            
            // Liberando todos os locks que este cara tenha
            this.resources_locked.clear(); 
			
			// Manda o status para os clientes
			this.BroadLockStatusToAll();


            // Aqui vou remover o Id do Telepointer
            servidor.RemovePointer(id_pointer);
            servidor.RemoveClient(this);
            
            this.interrupt();
        } catch (IOException e) {
            // e.printStackTrace();
        } 
    }           // disconnect
    
    public synchronized void BroadCastToClient (Object obj) {
        try {
            os.reset();
            os.writeObject(obj);
            os.flush();
            os.reset();
        } catch (IOException e) {
            disconnect();
            e.printStackTrace();
        }
    }           // BroadCastToClient

}
